// Author(s):
// - Huailu Ren, hlren.pub@gmail.com, http://lunix.cnblogs.com
// 

// Revision 1.0  9:56 2011-7-31  hlren
// created
//
#include "stdio.h"
#include "math.h"

int main(){
  FILE * f_r2b_v;//rgb2yuv_verification log file
  int r, g, b;
  int i;
  float y_f, u_f, v_f; // floating point calculation
  int y_h, u_h, v_h; // fixed point for hardware implementation
  
  if(NULL==(f_r2b_v = fopen("rgb2yuv.log","w"))){
    printf("open file rgb2yuv.log error!\n");
  }; 
  
  fprintf(f_r2b_v, "rgb2yuv testcase:\n");
  for(i=0;i<10;i=i+1) {
      r = (i+1)*(i+2)*(i+3)*19*23*29*41%4096;
      g = (i+1)*(i+2)*(i+3)*17*13*31*37%4096;
      b = (i+1)*(i+2)*(i+3)*13*11*37*41%4096;
      
      y_f =  (0.257 * r) + (0.504 * g) + (0.098 * b) + 256 ;
      u_f =  (0.439 * r) - (0.368 * g) - (0.071 * b) + 2048;
      v_f = -(0.148 * r) - (0.291 * g) + (0.439 * b) + 2048;
      
      y_h = ( (263 * r) + (516 * g) + (100 * b) + 262144 )>>10;
      u_h = ( (450 * r) - (377 * g) - ( 73 * b) + 2097152)>>10;
      v_h = (-(152 * r) - (298 * g) + (450 * b) + 2097152)>>10;
      
      fprintf(f_r2b_v, "%2d, rgb: %5d, %5d, %5d", i, r, g, b);
      fprintf(f_r2b_v, "\tyuv_f: %9.3f, %9.3f, %9.3f", y_f, u_f, v_f);
      fprintf(f_r2b_v, "\tyuv_h: %5d, %5d, %5d", y_h, u_h, v_h);
      
      if( (((fabsf(y_f - y_h))/y_f)<0.1) && 
          (((fabsf(u_f - u_h))/u_f)<0.1) &&
          (((fabsf(v_f - v_h))/v_f)<0.1) ){
        fprintf(f_r2b_v, "\tpass\n");
      }  
      else {
        //for debug
        fprintf(f_r2b_v, "\tdiff: \t%f,\t%f,\t%f",fabsf(y_f - y_h), fabsf(u_f - u_h), fabsf(v_f - v_h));  
        fprintf(f_r2b_v, "\tRatio: \t%f,\t%f,\t%f",
                        ((fabsf(y_f - y_h))/y_f), 
                        ((fabsf(u_f - u_h))/u_f), 
                        ((fabsf(v_f - v_h))/v_f));  
        fprintf(f_r2b_v, "\tnot pass\n");
      }
  }
}