// Author(s):
// - Huailu Ren, hlren.pub@gmail.com, http://lunix.cnblogs.com
// 

// Revision 1.0  9:56 2011-7-31  hlren
// created
//

// synopsys translate_off
`include "timescale.v"
// synopsys translate_on
module tb_rgb2yuv;

  reg clk, reset, idval;
  reg  [11:0] r, g, b;
  wire [11:0] y, u, v;
  wire odval;

  RGB2YCrCb DUT_rgb2yuv(	
    .iCLK   (clk),
    .iRESET (reset),
    .iRed   (r),
    .iGreen (g),
    .iBlue  (b),
    .iDVAL  (idval),
    .oY     (y),
    .oCr    (u),
    .oCb    (v),
    .oDVAL  (odval)
  );
  initial   clk = 0;
  always #5 clk = ~clk;
  
  initial 
  begin
    reset = 1;
    repeat (2) @ (posedge clk);
    reset = 0;
  end
  
  reg [11:0] veri_y[9:0];
  reg [11:0] veri_u[9:0];
  reg [11:0] veri_v[9:0];
  
  integer i;
  initial 
    begin
      idval = 0;
      repeat (3) @ (posedge clk);
      idval = 1;
      for(i=0;i<10;i=i+1)
        begin
          r = (i+1)*(i+2)*(i+3)*19*23*29*41%4096;
          g = (i+1)*(i+2)*(i+3)*17*13*31*37%4096;
          b = (i+1)*(i+2)*(i+3)*13*11*37*41%4096;
          
          veri_y[i] = ( (263 * r) + (516 * g) + (100 * b) + 262144 )>>10;
          veri_u[i] = ( (450 * r) - (377 * g) - ( 73 * b) + 2097152)>>10;
          veri_v[i] = (-(152 * r) - (298 * g) + (450 * b) + 2097152)>>10;
          
          //veri_y[i] =  (0.257 * r) + (0.504 * g) + (0.098 * b) + 256 ;
          //veri_u[i] =  (0.439 * r) - (0.368 * g) - (0.071 * b) + 2048;
          //veri_v[i] = -(0.148 * r) - (0.291 * g) + (0.439 * b) + 2048;
          
          repeat (1) @ (posedge clk);
        end
      idval = 0;
      repeat (100) @ (posedge clk);
      $finish;
    end
  
  integer j;
  
  always @ (posedge clk)
    if(reset)
      j <= 0;
    else if (odval)
      j <= j + 1;
    
  always @ (posedge clk)
  if (odval) begin
    $display("veri: \t%d,\t%d,\t%d, yuv: \t%d,\t%d,\t%d",
      veri_y[j],
      veri_u[j],
      veri_v[j],
      
      y, u, v);
  end
  
`ifdef FSDBDUMP
  initial 
  begin
    $fsdbDumpfile("test.fsdb");
    $fsdbDumpvars;
  end
`endif

endmodule
  
  